#!/bin/sh

# stats1.sh
# by Javantea
# Sept 9, 2006

A="21 22 23 25 37 53 80 113 135 139 443 445 1025 1433 3306 3389 5000 5800 5900 6000 6881 6882 6883 6884 6885 6886 6887 6888 6889"

echo "Number of open ports in port1:"
for port in $A; do 
	echo -n "Port $port: "
	grep "portid=\"$port\"><state state=\"open" port1/port1_*.xml |wc -l
done

echo "Number of filtered ports in port1:"
for port in $A; do 
	echo -n "Port $port: "
	grep "portid=\"$port\"><state state=\"filtered" port1/port1_*.xml |wc -l
done

echo "Number of closed ports in port1:"
for port in $A; do 
	echo -n "Port $port: "
	grep "portid=\"$port\"><state state=\"closed" port1/port1_*.xml |wc -l
done

# List of ips and ports for open ports in ports_all.
grep "<state state=\"open" port_all/port_all_*.xml | tr \"_. "   " |\
	gawk -F ' ' '{ print $4"." $5"." $6"." $7" " $12 }' > port_all/port_all_open1.txt
#port all/port all 12 207 205 192 xml:<port protocol= tcp  portid= 1025 ><state state= open  /><service name= NFS-or-IIS  method= table  conf= 3  /></port>
# becomes:
#12.207.205.192 1025

echo "Number of open ports in ports_all:"
B=`gawk -F ' ' '{ print $2 }' port_all/port_all_open1.txt | sort -n | uniq`

for port in $B; do 
	echo -n "Port $port: "
	grep " $port\$" port_all/port_all_open1.txt |wc -l
done

# List of ips and ports for filtered ports in ports_all.
grep "<state state=\"filtered" port_all/port_all_*.xml | tr \"_. "   " |\
	gawk -F ' ' '{ print $4"." $5"." $6"." $7" " $12 }' > port_all/port_all_filtered1.txt


echo "Number of filtered ports in ports_all:"
C=`gawk -F ' ' '{ print $2 }' port_all/port_all_filtered1.txt | sort -n | uniq`

for port in $C; do 
	echo -n "Port $port: "
	grep " $port\$" port_all/port_all_filtered1.txt |wc -l
done

# List of ips and ports for filtered ports in ports_all.
grep "<state state=\"closed" port_all/port_all_*.xml | tr \"_. "   " |\
	gawk -F ' ' '{ print $4"." $5"." $6"." $7" " $12 }' > port_all/port_all_closed1.txt


echo "Number of closed ports in ports_all:"
C=`gawk -F ' ' '{ print $2 }' port_all/port_all_closed1.txt | sort -n | uniq`

for port in $C; do 
	echo -n "Port $port: "
	grep " $port\$" port_all/port_all_closed1.txt |wc -l
done
